#include "Vector.h"

CVector::CVector()
{
	x = 0.0f;
	y = 0.0f;
	z = 0.0f;
}

CVector::CVector(float init_x, float init_y, float init_z)
{
	x = init_x;
	y = init_y;
	z = init_z;
}

CVector::CVector(const CVector& rhs)
{
	x = rhs.x;
	y = rhs.y;
	z = rhs.z;
}


CVector::~CVector()
{
	
}


//   -  Ϳ rhs Ͱ  Ѵ.
float CVector::Dot(const CVector& rhs)
{
	return (x * rhs.x + y * rhs.y + z * rhs.z);
}


//   - u Ϳ v Ͱ  ͸  ͷ .  
//     (this = u X v )
void CVector::Cross(const CVector& u, const CVector& v)
{
	
	x = u.y * v.z - u.z * v.y;
	y = u.z * v.x - u.x * v.z;
	z = u.x * v.y - u.y * v.x;
}

// Ϳ Į k   ͸ Ѵ.
CVector CVector::Scale(float k)
{
	return CVector(k*x, k*y, k*z);
}


//   ̸ Ѵ.
float CVector::Length()
{
	return float(sqrt(x*x + y*y + z*z));
}

//  Ϳ  ͸ Ѵ.
CVector CVector::Normalize()
{
	return Scale(1.0f/Length());
}

//  
// 纤Ϳ rhs   ͸ Ѵ.
CVector CVector::operator+(const CVector& rhs)
{
	return CVector(x+rhs.x , y+rhs.y , z+rhs.z);
}


// 纤Ϳ rhs   ͸ Ѵ.		
CVector CVector::operator-(const CVector& rhs)
{
	return CVector(x-rhs.x , y-rhs.y , z-rhs.z);
}

// rhs    ͷ Ѵ.
void CVector::operator=(const CVector& rhs)
{
	x = rhs.x;
	y = rhs.y;
	z = rhs.z;
}
