#if !defined(_CHAPTER11_SIMPLIFICATION_TRIANGLE_H_)
#define _CHAPTER11_SIMPLIFICATION_TRIANGLE_H_ 1


#include "swTVector.h"
#include <vector>
#include <set>


//---------------------------------------------------------------------------
// CVertex

class CVertex
{
public:
	//  CVertex 
	CVertex(double x, double y, double z)
	: pos_(x, y, z)
	{}
	//  CTriangle Ҹ
	~CVertex()  {}

	swTVector3<double>& getPos()  {  return pos_;  }
	const swTVector3<double>& getPos() const {  return pos_;  }

	void addTriangle(unsigned int id);

	double calcEdgeCollapseCost(const CVertex& vtx) const;

private:
	//    ǥϱ   ǥ
	swTVector3<double> pos_;

	//   ϴ ﰢ index set
	::std::set<unsigned int> triangleSet_;
};


//---------------------------------------------------------------------------
// CTriangle

class CTriangle
{
public:
	//  CTriangle 
	CTriangle(unsigned int v1, unsigned int v2, unsigned int v3, size_t id);
	//  CTriangle Ҹ
	~CTriangle()  {}

	void draw() const;

	CVertex getVertex(unsigned int i) const;

	swTVector3<double>& getNormal()  {  return normal_;  }
	const swTVector3<double>& getNormal() const {  return normal_;  }

	bool hasEdge(const CVertex& vtx1, const CVertex& vtx2) const;

private:
	//  ﰢ  ͸ 
	void calcNormal();

private:
	//  ﰢ ϴ   ε
	unsigned int v1_, v2_, v3_;

	//  ﰢ  
	swTVector3<double> normal_;
};


//--------------------------------------------------------------------------------------------------
//

extern ::std::vector<CVertex> vertexPool;
extern ::std::vector<CTriangle> trianglePool;


#endif  //  _CHAPTER11_SIMPLIFICATION_TRIANGLE_H_
