#include "BarSimulator.h"
#include <cstdarg>
#include <cstdio>
#include <cmath>
#include "glut.h"


//--------------------------------------------------------------------------------------------------
//

static double pi = 4.0 * atan(1.0);


//--------------------------------------------------------------------------------------------------
// gprintf

void gprintf(float x, float y, const char* fmt, ...)
{
	char buffer[200] = { '\0', };
	//  setup
	va_list argptr;
	
	//  analyze
	va_start(argptr, fmt);
	vsprintf(buffer, fmt, argptr);
	va_end(argptr);
	
	//  draw text
	::glRasterPos3f(x, y, 0.0f);
	
    char c, *s = buffer;
	while((c = *s++) != 0) glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, c);
}


//--------------------------------------------------------------------------------------------------
// CBarSimulator

//  CBarSimulator 
CBarSimulator::CBarSimulator(double len, double vy)
: bar_(len, vy), step_(0ul), maxStep_(1000ul)
{
}

//  ð t  simulation  ¸ Ѵ
void CBarSimulator::printInfo(double t)
{
	glColor3f(0.0f, 0.0f, 0.0f);

	gprintf(-3, 50, "displacement of point B: (%.4lf, 0)", bar_.calcPosB(t));	
	gprintf(-3, 48, "velocity of point B: (%.4lf, 0)", bar_.calcLinearVelB(t));	
	gprintf(-3, 46, "acceleration of point B: (%.4lf, 0)", bar_.calcLinearAccelB(t));	
	gprintf(-3, 44, "angular velocity of bar: %.4lf", bar_.calcAngularVel(t));	
	gprintf(-3, 42, "angular acceleration of bar: %.4lf", bar_.calcAngularAccel(t));	
}

//   ׸
void CBarSimulator::drawWall(double len)
{
	glColor3f(0.0f, 0.0f, 0.0f);
	glBegin(GL_LINE_STRIP);
		glVertex3d(0.0, len, 0.0);
		glVertex3d(0.0, 0.0, 0.0);
		glVertex3d(len, 0.0, 0.0);
	glEnd();
}

//  bar ׸
void CBarSimulator::drawBar(double len, double pos, double inclinedAngle)
{
	glTranslated(pos, 0.0, 0.0);
	glRotated(90.0 - inclinedAngle * 180 / pi, 0.0, 0.0, 1.0);

	double barWidth = 1.0;
	glColor3f(0.0f, 0.0f, 1.0f);
	glBegin(GL_QUADS);
		glVertex3d(0.0, 0.0, 0.0);
		glVertex3d(barWidth, 0.0, 0.0);
		glVertex3d(barWidth, len, 0.0);
		glVertex3d(0.0, len, 0.0);
	glEnd();
}

//  ð t  bar simulationѴ
void CBarSimulator::simulate()
{
	double t = bar_.getElapsedTime() * (step_ <= maxStep_ ?  double(step_) / double(maxStep_) : 1.0);

	printInfo(t);
	drawWall(bar_.getLength() * 1.2);
	drawBar(bar_.getLength(), bar_.calcPosB(t), bar_.calcInclinedAngle(t));

	++step_;
}
