#include "CartSimulator.h"
#include <cstdlib>
#include "glut.h"


//--------------------------------------------------------------------------------------------------
//

CCartSimulator simulator(-5.0, 2.0);


//--------------------------------------------------------------------------------------------------
//

void render(void)
{
	glClear(GL_COLOR_BUFFER_BIT);
	
	glPushMatrix();
	   simulator.simulate();
	glPopMatrix();
	   
	glutSwapBuffers();
}

void initialize(void) 
{
	glClearColor(1.0, 1.0, 1.0, 1.0);
	glShadeModel(GL_FLAT);
}

void reshape(int w, int h)
{
	glViewport(0, 0, (GLsizei)w, (GLsizei)h);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	double left = -7.0, right = 0.5, bottom = -0.1, top = 0.3;
	double widthVP = double(w), heightVP = double(h);
	double widthVR = right - left, heightVR = top - bottom;
    double ratioAR = (widthVP / heightVP) / (widthVR / heightVR);
	if (ratioAR >= 1.0)
		gluOrtho2D(left * ratioAR, right * ratioAR, bottom, top);
	else 
		gluOrtho2D(left, right, bottom / ratioAR, top / ratioAR);
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize(500, 200); 
	glutInitWindowPosition(100, 100);
	glutCreateWindow("Pinned Bar");
	
	initialize();
	
	glutDisplayFunc(render); 
	glutReshapeFunc(reshape); 
	glutIdleFunc(render);
	glutMainLoop();
	
	return 0;
}
