#include "Matrix.h"
#include <iostream>
#include <iomanip>

void printMatrix(const CMatrix3& mat)
{
	::std::cout.precision(5);
	::std::cout << '\t' << ::std::setw(10) << mat.element[0] << ::std::setw(10) << mat.element[3] << ::std::setw(10) << mat.element[6] << '\n';
	::std::cout << '\t' << ::std::setw(10) << mat.element[1] << ::std::setw(10) << mat.element[4] << ::std::setw(10) << mat.element[7] << '\n';
	::std::cout << '\t' << ::std::setw(10) << mat.element[2] << ::std::setw(10) << mat.element[5] << ::std::setw(10) << mat.element[8] << '\n';
}

int main()
{
	//      [  2  1  3  ]       [  1  0 -2  ]
	//  A = [  1  2 -1  ]   B = [  3  1 -1  ]
	//      [  2 -1  3  ]       [  0  4 -2  ]
	double array1[] = { 2.0, 1.0, 2.0, 1.0, 2.0, -1.0, 3.0, -1.0, 3.0 };
	double array2[] = { 1.0, 3.0, 0.0, 0.0, 1.0, 4.0, -2.0, -1.0, -2.0 };
	CMatrix3 matA(array1), matB(array2);
	CMatrix3 result; 

	::std::cout << " A\n";
	printMatrix(matA);
	::std::cout << " B\n";
	printMatrix(matB);

	::std::cout << ", I\n";
	result = matA;
	result.Identity();
	printMatrix(result);

	::std::cout << "ġ, A^T\n";
	result = matA;
	result.Transpose();
	printMatrix(result);

	::std::cout << " , A + B\n";
	result = matA + matB;
	printMatrix(result);

	::std::cout << " , A - B\n";
	result = matA - matB;
	printMatrix(result);

	::std::cout << " , A * B\n";
	result = matA * matB;
	printMatrix(result);

	::std::cout << "İ Į , 3 * A\n";
	result = matA;
	result.Scalar(3.0);
	printMatrix(result);

	::std::cout << "Ľ, det(A)\n";
	::std::cout << '\t' << matA.Det() << '\n';

	::std::cout << " , B^-1\n";
	result = matB.Inverse();
	printMatrix(result);

	::std::cout.flush();
	return 0;
}
